
FuturisticHUDMenuTitleR = 255
FuturisticHUDMenuTitleG = 255
FuturisticHUDMenuTitleB = 255
FuturisticHUDMenuTitleA = 175


FuturisticHUDMenuButtonR = 139
FuturisticHUDMenuButtonG = 131
FuturisticHUDMenuButtonB = 131
FuturisticHUDMenuButtonA = 100

FuturisticHUDMenuActiveButtonR = 255
FuturisticHUDMenuActiveButtonG = 255
FuturisticHUDMenuActiveButtonB = 255
FuturisticHUDMenuActiveButtonA = 175


FuturisticHUDGUI = {}
FuturisticHUDGUI.menu = {}
FuturisticHUDGUI.buttons = {}
FuturisticHUDGUI.navButtons = 	{
				["menuOpen"] = 
				{
					["keys"] = {},
					["menu"] = ""
				}, 
				["menuClose"] = {["keys"] = {}},
				["menuPrev"] = {["keys"] = {}},
				["navUp"] = {["keys"] = {}},
				["navDown"] = {["keys"] = {}},
				["select"] = {["keys"] = {}},
				["navBack"] = {["keys"] = {}}
			}
FuturisticHUDGUI.activeButton = 1
FuturisticHUDGUI.activeMenu = ""
FuturisticHUDGUI.statusText = {["text"] = "", ["time"] = 0}

FuturisticHUDGUI.titleColor = {["r"] = FuturisticHUDMenuTitleR, ["g"] = FuturisticHUDMenuTitleG, ["b"] = FuturisticHUDMenuTitleB, ["a"] = FuturisticHUDMenuTitleA}
FuturisticHUDGUI.buttonColor = {["r"] = FuturisticHUDMenuButtonR, ["g"] = FuturisticHUDMenuButtonG, ["b"] = FuturisticHUDMenuButtonB, ["a"] = FuturisticHUDMenuButtonA}
FuturisticHUDGUI.activeButtonColor = {["r"] = FuturisticHUDMenuActiveButtonR, ["g"] = FuturisticHUDMenuActiveButtonG, ["b"] = FuturisticHUDMenuActiveButtonB, ["a"] = FuturisticHUDMenuActiveButtonA}


function FuturisticHUDGUI.createMenu(menuName, prevMenu, title, xpos, ypos, xscale, yscale, buttonSpacing, textScale, font, saveButtonPos)
	if(FuturisticHUDGUI.menu[menuName] == nil) then
		FuturisticHUDGUI.menu[menuName] = {}
		lastOffset = ypos + yscale + buttonSpacing
	end
	
	FuturisticHUDGUI.menu[menuName] = {
		["prevMenu"] = prevMenu,
		["title"] = title,
		["xpos"] = xpos,
		["ypos"] = ypos,
		["xscale"] = xscale,
		["yscale"] = yscale,
		["spacing"] = buttonSpacing,
		["lastOffset"] = lastOffset,
		["numButtons"] = 0,
		["textScale"] = textScale,
		["lastButton"] = 1,
		["saveButtonPos"] = saveButtonPos,
		["font"] = font
	}
end

function FuturisticHUDGUI.addButton(parentMenu, text, funct, args, toggleable, textScale, font)
	if(FuturisticHUDGUI.buttons[parentMenu] == nil or FuturisticHUDGUI.buttons[parentMenu]["settings"] == nil) then
		FuturisticHUDGUI.buttons[parentMenu] = {["settings"] = {}}
	end

	local currButtonNum = #FuturisticHUDGUI.buttons[parentMenu].settings + 1
	FuturisticHUDGUI.menu[parentMenu].numButtons = currButtonNum

	if(toggleable) then
		toggledOn = false
	else
	    toggledOn = nil
	end

	FuturisticHUDGUI.buttons[parentMenu].settings[currButtonNum] = {
		["parentMenu"] = parentMenu,
		["text"] = text,
		["funct"] = funct,
		["args"] = args,
		["font"] = font,
		["xpos"] = FuturisticHUDGUI.menu[parentMenu].xpos,
		["ypos"] = FuturisticHUDGUI.menu[parentMenu].lastOffset,
		["xscale"] = FuturisticHUDGUI.menu[parentMenu].xscale,
		["yscale"] = FuturisticHUDGUI.menu[parentMenu].yscale,
		["textScale"] = textScale,
		["toggleable"] = toggleable,
		["toggledOn"] = toggledOn
	}

	FuturisticHUDGUI.menu[parentMenu]["lastOffset"] = (FuturisticHUDGUI.menu[parentMenu].lastOffset + FuturisticHUDGUI.menu[parentMenu].yscale + FuturisticHUDGUI.menu[parentMenu].spacing)
end

function FuturisticHUDGUI.setActiveMenu(menuName)
	FuturisticHUDGUI.activeMenu = menuName
	if(FuturisticHUDGUI.menu[FuturisticHUDGUI.activeMenu] ~= nil) then
		if(FuturisticHUDGUI.menu[FuturisticHUDGUI.activeMenu].saveButtonPos or FuturisticHUDGUI.menu[FuturisticHUDGUI.activeMenu].saveButtonPos == nil) then
			FuturisticHUDGUI.activeButton = FuturisticHUDGUI.menu[FuturisticHUDGUI.activeMenu].lastButton
		else
		    FuturisticHUDGUI.activeButton = 1
		end
	end
end

function FuturisticHUDGUI.updateStatusText(text, time)
	FuturisticHUDGUI.statusText = {["text"] = text, ["time"] = time}
end

function FuturisticHUDGUI.isActiveButtonToggledOn()
	local activeButton = FuturisticHUDGUI.buttons[FuturisticHUDGUI.activeMenu].settings[FuturisticHUDGUI.activeButton]
	if(activeButton.toggleable) then
		return activeButton.toggledOn
	elseif(activeButton.toggleable == false) then
	    return nil
	end
end

function FuturisticHUDGUI.isButtonToggledOn(menu, index)
	local activeButton = FuturisticHUDGUI.buttons[menu].settings[index]
	if(activeButton.toggleable) then
		return activeButton.toggledOn
	elseif(activeButton.toggleable == false) then
	    return nil
	end
end

function FuturisticHUDGUI.toggleActiveButtonState()
	local activeButton = FuturisticHUDGUI.buttons[FuturisticHUDGUI.activeMenu].settings[FuturisticHUDGUI.activeButton]


	if(FuturisticHUDGUI.isActiveButtonToggledOn() and activeButton.toggleable) then
		activeButton.toggledOn = false
	elseif(FuturisticHUDGUI.isActiveButtonToggledOn() == false and activeButton.toggleable) then
		activeButton.toggledOn = true
	end
end

function FuturisticHUDGUI.toggleButtonState(menu, index)
	local activeButton = FuturisticHUDGUI.buttons[menu].settings[index]
	
	if(FuturisticHUDGUI.isButtonToggledOn(menu, index) and activeButton.toggleable) then
		activeButton.toggledOn = false
	elseif(FuturisticHUDGUI.isButtonToggledOn(menu, index) == false and activeButton.toggleable) then
		activeButton.toggledOn = true
	end
end

function FuturisticHUDGUI.removeButton(parentMenu, index)
	FuturisticHUDGUI.buttons[parentMenu].settings[index] = nil
	FuturisticHUDGUI.menu[parentMenu]["lastOffset"] = (FuturisticHUDGUI.menu[parentMenu].lastOffset - FuturisticHUDGUI.menu[parentMenu].yscale - FuturisticHUDGUI.menu[parentMenu].spacing)
end

function FuturisticHUDGUI.removeMenu(menuName)
	FuturisticHUDGUI.menu[menuName] = nil
end

function FuturisticHUDGUI.drawStatusText()
	if(nextDrawTime == nil or prevText ~= FuturisticHUDGUI.statusText.text) then
		nextDrawTime = natives.GAMEPLAY.GET_GAME_TIMER() + FuturisticHUDGUI.statusText.time
	end

	if(nextDrawTime > natives.GAMEPLAY.GET_GAME_TIMER()) then
		prevText = FuturisticHUDGUI.statusText.text
		natives.UI.SET_TEXT_FONT(0)
		natives.UI.SET_TEXT_SCALE(0.55, 0.55)
		natives.UI.SET_TEXT_COLOUR(255, 255, 255, 255)
		natives.UI.SET_TEXT_WRAP(0.0, 1.0)
		natives.UI.SET_TEXT_OUTLINE(1)
		natives.UI.SET_TEXT_CENTRE(true)
		natives.UI.SET_TEXT_DROPSHADOW(1, 0, 0, 255, 255)
		natives.UI.SET_TEXT_EDGE(1, 0, 0, 0, 205)
		natives.UI._SET_TEXT_ENTRY("STRING")
		natives.UI._ADD_TEXT_COMPONENT_STRING(FuturisticHUDGUI.statusText.text)
		natives.UI._DRAW_TEXT(0.5, 0.9)
	else
		FuturisticHUDGUI.statusText = {["text"] = "", ["time"] = 0}
		nextDrawTime = nil
	end
end

function FuturisticHUDGUI.drawFuturisticHUDGUI()
	if(FuturisticHUDGUI.activeMenu ~= "" and FuturisticHUDGUI.activeMenu ~= nil) then
		local name = FuturisticHUDGUI.activeMenu

		if(FuturisticHUDGUI.menu[name] ~= nil) then
			local xpos = FuturisticHUDGUI.menu[name].xpos
			local ypos = FuturisticHUDGUI.menu[name].ypos
			local xscale = FuturisticHUDGUI.menu[name].xscale
			local yscale = FuturisticHUDGUI.menu[name].yscale
			
			local text = FuturisticHUDGUI.menu[name].title
			local textScale = FuturisticHUDGUI.menu[name].textScale
			local font = FuturisticHUDGUI.menu[name].font
			
			local colors = FuturisticHUDGUI.titleColor

			FuturisticHUDGUI.addButtonText(text, xpos, ypos - 0.007, textScale, font)
			natives.GRAPHICS.REQUEST_STREAMED_TEXTURE_DICT("phone_wallpaper_badgerdefault", true)
			natives.GRAPHICS.DRAW_SPRITE("phone_wallpaper_badgerdefault", "phone_wallpaper_badgerdefault", xpos, ypos, xscale, yscale, 0, colors.r, colors.g, colors.b, colors.a)

			if(FuturisticHUDGUI.buttons[name] ~= nil) then
				for i, v in pairs(FuturisticHUDGUI.buttons[name].settings) do
					local buttonSettings = FuturisticHUDGUI.buttons[name].settings[i]
					local xpos = buttonSettings.xpos
					local ypos = buttonSettings.ypos
					local xscale = buttonSettings.xscale
					local yscale = buttonSettings.yscale
					
					local font = buttonSettings.font
					local text = buttonSettings.text
					local textScale = buttonSettings.textScale
					local colors = FuturisticHUDGUI.buttonColor

					if(buttonSettings.toggledOn == true) then
						text = buttonSettings.text .. "~w~ [ON]"
					elseif(buttonSettings.toggledOn == false) then
						text = buttonSettings.text .. " [OFF]"
					end
					
					if(i == FuturisticHUDGUI.activeButton) then
						colors = FuturisticHUDGUI.activeButtonColor
					end

					FuturisticHUDGUI.addButtonText(text, xpos, ypos, textScale, font)
					natives.GRAPHICS.REQUEST_STREAMED_TEXTURE_DICT("pause_menu_pages_gallery", true)
					natives.GRAPHICS.DRAW_SPRITE("pause_menu_pages_gallery", "imagehighlight", xpos, ypos, xscale, yscale, 0, colors.r, colors.g, colors.b, colors.a)
				end
			else
				print("Menu ", name, " has no buttons!")
				FuturisticHUDGUI.setActiveMenu("")
			end
		else
			print("No menu created with the name: ", FuturisticHUDGUI.activeMenu)
			FuturisticHUDGUI.setActiveMenu("")
		end
	end
end

function FuturisticHUDGUI.addButtonText(text, xpos, ypos, textScale, font)
	if(text ~= nil and xpos ~= nil and ypos ~= nil and textScale ~= nil and font ~= nil) then
		natives.UI.SET_TEXT_FONT(font)
		natives.UI.SET_TEXT_SCALE(0.0, textScale)
		natives.UI.SET_TEXT_COLOUR(255, 255, 255, 255)
		natives.UI.SET_TEXT_CENTRE(true)
		natives.UI.SET_TEXT_OUTLINE(1)
		natives.UI.SET_TEXT_DROPSHADOW(1, 0, 0, 255, 255)
		natives.UI.SET_TEXT_EDGE(0, 0, 0, 0, 0)
		natives.UI._SET_TEXT_ENTRY("STRING")
		natives.UI._ADD_TEXT_COMPONENT_STRING(text)
		natives.UI._DRAW_TEXT(xpos, ypos - 0.0125)
	else
		print("text: ", text, ", xpos: ", xpos, ", ypos: ", ypos, ", textScale: ", textScale, ", font: ", font)
	    print("There seems to be a nil value when trying to add text to button (see above)")
	end
end

function FuturisticHUDGUI.runButtonFunct(currButton)
	if(type(currButton.funct) == "function" and currButton.args ~= nil and type(currButton.args) ~= "string" and type(currButton.args) ~= "number" and type(currButton.args) ~= "boolean") then
		currButton.funct(currButton.args[1], currButton.args[2], currButton.args[3], currButton.args[4], currButton.args[5], currButton.args[6], currButton.args[7], currButton.args[8], currButton.args[9], currButton.args[10], currButton.args[11], currButton.args[12], currButton.args[13], currButton.args[14], currButton.args[15], currButton.args[16], currButton.args[17], currButton.args[18], currButton.args[19], currButton.args[20])
		return true
	end

	if(type(currButton.funct) == "function" and type(currButton.args) == "string" or type(currButton.args) == "number" or type(currButton.args) == "boolean") then
		currButton.funct(currButton.args)
		return true
	end

	if(currButton.funct ~= nil and currButton.args == nil  ) then
		currButton.funct()
		return true
	end

	if(currButton.funct == nil) then
		print("Unabled to run the function")
		return false
	end
end

function FuturisticHUDGUI.tick()
	FuturisticHUDGUI.drawStatusText()
	FuturisticHUDGUI.drawFuturisticHUDGUI()

	for i, key in pairs(FuturisticHUDGUI.navButtons.menuOpen.keys) do
		if(IsKeyDown(key)) then
			natives.AUDIO.PLAY_SOUND_FRONTEND(-1, "QUIT_WHOOSH", "HUD_MINI_GAME_SOUNDSET", false)
			if(FuturisticHUDGUI.activeMenu == FuturisticHUDGUI.navButtons.menuOpen.menu) then
				FuturisticHUDGUI.setActiveMenu(FuturisticHUDGUI.menu[FuturisticHUDGUI.activeMenu].prevMenu)
			else
			    FuturisticHUDGUI.setActiveMenu(FuturisticHUDGUI.navButtons.menuOpen.menu)
			    FuturisticHUDGUI.currentSelection = 1
			end
		end
	end
	if FuturisticHUDGUI.activeMenu ~= "" then
		for i, key in pairs(FuturisticHUDGUI.navButtons.menuClose.keys) do
			if(IsKeyDown(key)) then
				natives.AUDIO.PLAY_SOUND_FRONTEND(-1, "Pin_Centred", "DLC_HEIST_BIOLAB_PREP_HACKING_SOUNDS", false)
				FuturisticHUDGUI.setActiveMenu("")
			end
		end
	end
	if FuturisticHUDGUI.activeMenu ~= "" then
		for k, key in pairs(FuturisticHUDGUI.navButtons.navUp.keys) do
			if(IsKeyDown(key) and FuturisticHUDGUI.activeMenu ~= "") then
				FuturisticHUDGUI.activeButton = FuturisticHUDGUI.activeButton - 1
				FuturisticHUDGUI.menu[FuturisticHUDGUI.activeMenu].lastButton = FuturisticHUDGUI.activeButton
				natives.AUDIO.PLAY_SOUND_FRONTEND(-1, "Pin_Centred", "DLC_HEIST_BIOLAB_PREP_HACKING_SOUNDS", false)
				
				if(FuturisticHUDGUI.activeButton <= 0) then
					FuturisticHUDGUI.activeButton = FuturisticHUDGUI.menu[FuturisticHUDGUI.activeMenu].numButtons
					FuturisticHUDGUI.menu[FuturisticHUDGUI.activeMenu].lastButton = FuturisticHUDGUI.activeButton
				end
			end
		end
	end
	if FuturisticHUDGUI.activeMenu ~= "" then
		for k, key in pairs(FuturisticHUDGUI.navButtons.navDown.keys) do
			if(IsKeyDown(key) and FuturisticHUDGUI.activeMenu ~= "") then
				FuturisticHUDGUI.activeButton = FuturisticHUDGUI.activeButton + 1
				FuturisticHUDGUI.menu[FuturisticHUDGUI.activeMenu].lastButton = FuturisticHUDGUI.activeButton
				natives.AUDIO.PLAY_SOUND_FRONTEND(-1, "Pin_Centred", "DLC_HEIST_BIOLAB_PREP_HACKING_SOUNDS", false)

				if(FuturisticHUDGUI.activeButton > FuturisticHUDGUI.menu[FuturisticHUDGUI.activeMenu].numButtons) then
					FuturisticHUDGUI.activeButton = 1
					FuturisticHUDGUI.menu[FuturisticHUDGUI.activeMenu].lastButton = FuturisticHUDGUI.activeButton
				end
			end
		end
	end
	if FuturisticHUDGUI.activeMenu ~= "" then
		for k, key in pairs(FuturisticHUDGUI.navButtons.select.keys) do
			if(IsKeyDown(key) and FuturisticHUDGUI.activeMenu ~= "") then
				
				local currButton = FuturisticHUDGUI.buttons[FuturisticHUDGUI.activeMenu].settings[FuturisticHUDGUI.activeButton]
				natives.AUDIO.PLAY_SOUND_FRONTEND(-1, "Pin_Centred", "DLC_HEIST_BIOLAB_PREP_HACKING_SOUNDS", false)

				if(FuturisticHUDGUI.runButtonFunct(currButton)) then
					if(currButton.toggleable) then
						FuturisticHUDGUI.toggleActiveButtonState()
					end
				end
			end
		end
	end
	if FuturisticHUDGUI.activeMenu ~= "" then
		for k, key in pairs(FuturisticHUDGUI.navButtons.navBack.keys) do
			if(IsKeyDown(key) and FuturisticHUDGUI.activeMenu ~= "") then
				FuturisticHUDGUI.setActiveMenu(FuturisticHUDGUI.menu[FuturisticHUDGUI.activeMenu].prevMenu)
				natives.AUDIO.PLAY_SOUND_FRONTEND(-1, "Pin_Centred", "DLC_HEIST_BIOLAB_PREP_HACKING_SOUNDS", false);
			end
		end
	end
end

function FuturisticHUDGUI:OnError()
	--self:Kill()
	--addon.Load("RENAMEME")
end